(window.webpackJsonp=window.webpackJsonp||[]).push([[0],{145:function(module,__webpack_exports__,__webpack_require__){"use strict";var crud_repo_implementingvue_type_script_lang_ts_=__webpack_require__(0).default.extend({name:"implementing"}),componentNormalizer=__webpack_require__(1),component=Object(componentNormalizer.a)(crud_repo_implementingvue_type_script_lang_ts_,function(){var _vm=this,_h=_vm.$createElement,_c=_vm._self._c||_h;return _c("content-page",{attrs:{title:"CRUD repository"}},[_c("h2",[_vm._v("Implementing")]),_vm._v(" "),_c("p",[_vm._v("\n        First you should create your base crud repo by extending from AbstractCRUDRepo and implementing its several abstract methods which will call the server side.\n        It can look something like this:\n    ")]),_vm._v(" "),_c("v-code",[_vm._v("\n        class CRUDRepo<T> extends IWithId> extends AbstractCRUDRepository<T> {\n            async sendAddReq(instance: T, ...params) {\n                return await ApiClient.send({\n                    path: this.api.add,\n                    bodyParams: instance\n                })\n            }\n            async sendDeleteReq(instance: T, ...params) {\n                return await ApiClient.send({\n                    path: this.api.delete,\n                    urlParams: {id: instance.id}\n                })\n            }\n            async sendEditReq(instance: T, ...params) {\n                return await ApiClient.send({\n                    path: this.api.edit,\n                    bodyParams: instance\n                })\n            }\n            async sendGetReq(id, ...params) {\n                return await ApiClient.send({\n                    path: this.api.get,\n                    urlParams: {id: instance.id}\n                })\n            }\n            async sendListReq(...params) {\n                return await ApiClient.send({path: this.api.list})\n            }\n        }\n    ")]),_vm._v(" "),_c("p",[_vm._v("\n        Now you can create a repo for entity that has a crud methods by simple extending your CRUDRepo and you'll got all of functionality.\n        Passing of entity type to CRUDRepo gives us full types control in repo.\n        Passing of api description need to use it in you api client to send correct requests.\n    ")]),_vm._v(" "),_c("v-code",[_vm._v("\n        class TaskRepo extends CRUDRepo<Task> {\n            super({\n                list: 'api/tasks/list',\n                get: 'api/tasks/get',\n                add: 'api/tasks/add',\n                edit: 'api/tasks/edit',\n                delete: 'api/tasks/delete'\n            })\n        }\n        export const taskRepo = new TaskRepo()\n    ")])],1)},[],!1,null,"0cf8e6ea",null);__webpack_exports__.a=component.exports},146:function(module,__webpack_exports__,__webpack_require__){"use strict";var components_content_pagevue_type_script_lang_js_=__webpack_require__(0).default.extend({name:"content-page",props:{title:{type:String}}}),componentNormalizer=__webpack_require__(1),component=Object(componentNormalizer.a)(components_content_pagevue_type_script_lang_js_,function(){var _h=this.$createElement,_c=this._self._c||_h;return _c("section",{staticClass:"content"},[_c("h1",[this._v(this._s(this.title))]),this._v(" "),this._t("default")],2)},[],!1,null,"7a95a420",null);__webpack_exports__.a=component.exports},147:function(module,__webpack_exports__,__webpack_require__){"use strict";var crud_repo_get_methodsvue_type_script_lang_ts_=__webpack_require__(0).default.extend({name:"get-methods"}),componentNormalizer=__webpack_require__(1),component=Object(componentNormalizer.a)(crud_repo_get_methodsvue_type_script_lang_ts_,function(){var _h=this.$createElement,_c=this._self._c||_h;return _c("content-page",{attrs:{title:"CRUD repository"}},[_c("h2",[this._v('"Get" methods')]),this._v(" "),_c("v-code",[this._v("\n        // Send get request to server and activate response\n        await taskRepository.getAndActivate(id)\n\n        // Send get request to server\n        // Replace task by response\n        // Activate response if task was active\n        await taskRepository.refreshItem(task)\n\n        //Same as above but works by id\n        await taskRepository.refreshItemById(id)\n    ")])],1)},[],!1,null,"6d59e9b3",null);__webpack_exports__.a=component.exports},148:function(module,__webpack_exports__,__webpack_require__){"use strict";var intro_what_is_vue_repovue_type_script_lang_ts_=__webpack_require__(0).default.extend({name:"what-is-vue-repo"}),componentNormalizer=__webpack_require__(1),component=Object(componentNormalizer.a)(intro_what_is_vue_repovue_type_script_lang_ts_,function(){var _vm=this,_h=_vm.$createElement,_c=_vm._self._c||_h;return _c("content-page",{attrs:{title:"Introduction"}},[_c("h2",[_vm._v("What is vue-repo?")]),_vm._v(" "),_c("p",[_vm._v("\n        It's modular, easy-scalable, class-based, reactive state-management implementation, written on typescript.\n        And it has several base classes from the box which will simplify your work and significantly reduce the routine.\n        Look at that:\n    ")]),_vm._v(" "),_c("h2",[_vm._v("1 - Extend abstract base class and implement its abstract methods")]),_vm._v(" "),_c("v-code",[_vm._v("\n        // You can access api description from this.api\n        class CRUDRepo<T> extends IWithId> extends AbstractCRUDRepository<T> {\n            async sendAddReq(instance: T, ...params) {\n                return await ApiClient.send({\n                    path: this.api.add,\n                    bodyParams: instance\n                })\n            }\n            async sendDeleteReq(instance: T, ...params) {\n                return await ApiClient.send({\n                    path: this.api.delete,\n                    urlParams: {id: instance.id}\n                })\n            }\n            async sendEditReq(instance: T, ...params) {\n                return await ApiClient.send({\n                    path: this.api.edit,\n                    bodyParams: instance\n                })\n            }\n            async sendGetReq(id, ...params) {\n                return await ApiClient.send({\n                    path: this.api.get,\n                    urlParams: {id: instance.id}\n                })\n            }\n            async sendListReq(...params) {\n                return await ApiClient.send({path: this.api.list})\n            }\n        }\n    ")]),_vm._v(" "),_c("h2",[_vm._v("2 - Create your repo and describe api pathes")]),_vm._v(" "),_c("v-code",[_vm._v("\n        class TaskRepo extends CRUDRepo<Task> {\n            super({\n                list: 'api/tasks/list',\n                get: 'api/tasks/get',\n                add: 'api/tasks/add',\n                edit: 'api/tasks/edit',\n                delete: 'api/tasks/delete'\n            })\n        }\n        export const taskRepo = new TaskRepo()\n    ")]),_vm._v(" "),_c("h2",[_vm._v("3 - You're ready to use your first repo!")]),_vm._v(" "),_c("v-code",[_vm._v("\n        // -- Case 1 --\n        // Get from server list of tasks and save it to repo\n        await taskRepo.updateList()\n        taskRepo.list // list of tasks\n\n        // -- Case 2 --\n        // Activate first task\n        taskRepo.activateFirst()\n        taskRepo.hasActive // true\n        taskRepo.isActive(taskRepo.list[0]) // true\n        taskRepo.isActive(taskRepo.list[3]) // false\n        // Edit name of active task\n        taskRepo.active.name = 'edited'\n        // Save to server edited task and change local object by response\n        await taskRepo.editActive()\n\n        // -- Case 3 --\n        // Add new task on server and local\n        await taskRepo.add({ name: 'new-task' })\n\n        // -- Case 4 --\n        // Add new task local\n        taskRepo.addLocal({ name: 'new-unsaved-task' })\n        // Change its name\n        taskRepo.first.name = 'new-saved-task'\n        // Save to server and change object by response\n        await taskRepo.flushAdded(taskRepo.first)\n\n        // -- Case 5 --\n        // Add new task local\n        taskRepo.addLocal({ name: 'new-unsaved-task' })\n        // Delete all local-added tasks\n        taskRepo.deleteAllAdded()\n\n    ")])],1)},[],!1,null,"46acab36",null);__webpack_exports__.a=component.exports},149:function(module,__webpack_exports__,__webpack_require__){"use strict";var intro_quick_startvue_type_script_lang_ts_=__webpack_require__(0).default.extend({name:"quick-start"}),componentNormalizer=__webpack_require__(1),component=Object(componentNormalizer.a)(intro_quick_startvue_type_script_lang_ts_,function(){var _h=this.$createElement,_c=this._self._c||_h;return _c("content-page",{attrs:{title:"Introduction"}},[_c("h2",[this._v("Quick start")])])},[],!1,null,"65ac3a76",null);__webpack_exports__.a=component.exports},150:function(module,__webpack_exports__,__webpack_require__){"use strict";var store_module_what_is_store_modulevue_type_script_lang_ts_=__webpack_require__(0).default.extend({name:"store-module-middlewares"}),componentNormalizer=__webpack_require__(1),component=Object(componentNormalizer.a)(store_module_what_is_store_modulevue_type_script_lang_ts_,function(){var _vm=this,_h=_vm.$createElement,_c=_vm._self._c||_h;return _c("content-page",{attrs:{title:"Store module"}},[_c("h2",[_vm._v("What is Store-module?")]),_vm._v(" "),_c("p",[_vm._v("\n        It's a main base class, which purpose is to properties reactive.\n        Let's look how we can use it.\n    ")]),_vm._v(" "),_c("h2",[_vm._v("@State")]),_vm._v(" "),_c("p",[_vm._v('@State directive apply to class properties and makes it reactive. You can use it in your Vue components as it were in its "data" block.')]),_vm._v(" "),_c("v-code",[_vm._v("\n        class TaskRepo extends StoreModule {\n            @State()\n            public someProp: string\n        }\n    ")]),_vm._v(" "),_c("h2",[_vm._v("@Mutation")]),_vm._v(" "),_c("p",[_vm._v("Ok now we need to change this state. @Mutation is a method which change "),_c("b",[_vm._v("local")]),_vm._v(" state")]),_vm._v(" "),_c("v-code",[_vm._v("\n        class TaskRepo extends StoreModule {\n            @State()\n            public someProp: string\n            @Mutation()\n            public setSomeProp (val: string) {\n                this.someProp = val\n            }\n        }\n    ")]),_vm._v(" "),_c("p",[_vm._v("You can change it directly by v-model=\"taskRepo.someProp\" or taskRepo.someProp = 'new val' but in large applications it can be a cause of misunderstanding of your dataflow.")]),_vm._v(" "),_c("h2",[_vm._v("@Action")]),_vm._v(" "),_c("p",[_vm._v("Action is an async state change. For example you need to update someState on server side")]),_vm._v(" "),_c("v-code",[_vm._v("\n        class TaskRepo extends StoreModule {\n            @State()\n            public someProp: string\n            @Mutation()\n            public setSomeProp (val: string) {\n                this.someProp = val\n            }\n            @Action()\n            public updateSomeProp (val: string) {\n                const resp = Api.request({\n                    path: 'api/some/edit',\n                    urlParams: { val }\n                })\n                this.setSomeProp(resp)\n            }\n        }\n    ")]),_vm._v(" "),_c("h2",[_vm._v("@Getter")]),_vm._v(" "),_c("p",[_vm._v("Getter is a reactive computed property. It could be based on your state or not.")]),_vm._v(" "),_c("v-code",[_vm._v("\n        class TaskRepo extends StoreModule {\n            @State()\n            public someProp: string\n            @Mutation()\n            public setSomeProp (val: string) {\n                this.someProp = val\n            }\n            @Action()\n            public updateSomeProp (val: string) {\n                const resp = Api.request({\n                    path: 'api/some/edit',\n                    urlParams: { val }\n                })\n                this.setSomeProp(resp)\n            }\n            @Getter()\n            public get someComputedProp () {\n                return this.someState + '_' + Date.now()\n            }\n        }\n    ")])],1)},[],!1,null,"b6d9e88e",null);__webpack_exports__.a=component.exports},151:function(module,__webpack_exports__,__webpack_require__){"use strict";var store_module_optionsvue_type_script_lang_ts_=__webpack_require__(0).default.extend({name:"store-module-options"}),componentNormalizer=__webpack_require__(1),component=Object(componentNormalizer.a)(store_module_optionsvue_type_script_lang_ts_,function(){var _h=this.$createElement,_c=this._self._c||_h;return _c("content-page",{attrs:{title:"Store module"}},[_c("h2",[this._v("Options")]),this._v(" "),_c("p",[this._v("You can pass any options to annotations and handle it in middlewares")]),this._v(" "),_c("v-code",[this._v("\n        import {IGetterOptions} from '@/StoreModule/annotations';\n        import {addGetterMiddleware} from '@/StoreModule/middlewares';\n        // Augment options interface\n        declare module '@/StoreModule/annotations' {\n            interface IGetterOptions {\n                cache: true\n            }\n        }\n\n        addGetterMiddleware(\n            (options, target, propertyKey, descriptor) => {\n                // do something with options. For example wrap getter method to decorator which will implement a cache\n            }\n        )\n    ")])],1)},[],!1,null,"6698f5b7",null);__webpack_exports__.a=component.exports},152:function(module,__webpack_exports__,__webpack_require__){"use strict";var crud_repo_what_is_crud_repovue_type_script_lang_ts_=__webpack_require__(0).default.extend({name:"what-is-crud-repo"}),componentNormalizer=__webpack_require__(1),component=Object(componentNormalizer.a)(crud_repo_what_is_crud_repovue_type_script_lang_ts_,function(){var _h=this.$createElement,_c=this._self._c||_h;return _c("content-page",{attrs:{title:"CRUD repository"}},[_c("h2",[this._v("What is CRUD repository")]),this._v(" "),_c("p",[this._v("\n        It's one of the built-in base repos and the most powerful.\n        Extending it you get a clever system which will be highly helpful in your crud operations.\n    ")])])},[],!1,null,"e681053e",null);__webpack_exports__.a=component.exports},153:function(module,__webpack_exports__,__webpack_require__){"use strict";var components_v_codevue_type_script_lang_js_={name:"v-code",computed:{code:function(){return this.$slots.default[0].text}}},componentNormalizer=__webpack_require__(1),component=Object(componentNormalizer.a)(components_v_codevue_type_script_lang_js_,function(){var _h=this.$createElement,_c=this._self._c||_h;return _c("div",[_c("prism",{attrs:{code:this.code}})],1)},[],!1,null,"5a573fa7",null);__webpack_exports__.a=component.exports},154:function(module,__webpack_exports__,__webpack_require__){"use strict";var crud_repo_list_statevue_type_script_lang_ts_=__webpack_require__(0).default.extend({name:"list-state"}),componentNormalizer=__webpack_require__(1),component=Object(componentNormalizer.a)(crud_repo_list_statevue_type_script_lang_ts_,function(){var _h=this.$createElement,_c=this._self._c||_h;return _c("content-page",{attrs:{title:"CRUD repository"}},[_c("h2",[this._v("List state")]),this._v(" "),_c("p",[this._v("\n        Usually there are a list of objects for each entity in our app, which we get from server, save it local and draw a view.\n        It can be a table where each row is an object from list.\n        Let's look how we can work with lists vue-repo:\n    ")]),this._v(" "),_c("v-code",[this._v('\n        // List of tasks accessor\n        taskRepo.list\n\n        // Get list of tasks from server and save it to "list" state\n        await taskRepo.updateList()\n\n        // Or set list local\n        taskRepo.setList(listOfTasks)\n\n        // Clear list\n        taskRepo.clearList()\n\n        // Some helpful getters\n        taskRepo.hasList // boolean\n        taskRepo.isListEmpty // boolean\n        taskRepo.listItemByIndex(index) // task\n        taskRepo.listItemById(id) // task\n        taskRepo.listIndex(task) // number\n        taskRepo.listIndexById(id) // number\n        taskRepo.listMap // { [id: string | number]: task }\n        taskRepo.listIds // string[] | number[]\n        taskRepo.listLength // number\n        taskRepo.listLastIndex // number\n        taskRepo.listLastItem // task\n        taskRepo.listFirstItem // task\n    ')]),this._v(" "),_c("p",[this._v("\n        Easy and very helpful, isn't it?\n    ")])],1)},[],!1,null,"5db59b91",null);__webpack_exports__.a=component.exports},155:function(module,__webpack_exports__,__webpack_require__){"use strict";var crud_repo_active_statevue_type_script_lang_ts_=__webpack_require__(0).default.extend({name:"active-state"}),componentNormalizer=__webpack_require__(1),component=Object(componentNormalizer.a)(crud_repo_active_statevue_type_script_lang_ts_,function(){var _vm=this,_h=_vm.$createElement,_c=_vm._self._c||_h;return _c("content-page",{attrs:{title:"CRUD repository"}},[_c("h2",[_vm._v("Active state")]),_vm._v(" "),_c("p",[_vm._v("\n        Often we want to activate locally some item to edit, delete or something else in future.\n        That's how we can work with active items in vue-repo:\n    ")]),_vm._v(" "),_c("v-code",[_vm._v("\n        // Active task accessor\n        taskRepo.active\n\n        // Set task to active\n        taskRepo.activate(task)\n        taskRepo.activateFirst()\n        taskRepo.activateLast()\n        taskRepo.activateByIndex(index)\n\n        // Activate task2 if task1 is active\n        taskRepo.activateInstead(task1, task2)\n        taskRepo.activateInsteadById(task1.id, task2)\n\n        // Clear active state\n        taskRepo.deactivate()\n        taskRepo.deactivateIfActive(task)\n\n        // Helpful getters\n        taskRepo.hasActive // boolean\n        taskRepo.isActive(task) // boolean\n        taskRepo.isActiveById(task.id) // boolean\n        taskRepo.isActiveNew // boolean\n    ")]),_vm._v(" "),_c("p",[_vm._v('\n        A cool feature that when item is activating, repo saves a copy(by deep cloning) to state called "activeInitialCopy".\n        It gives us a bit of power:\n    ')]),_vm._v(" "),_c("v-code",[_vm._v('\n        taskRepo.isActiveChangedAfterActivation // true if "active" is not deep equals to "activeInitialCopy"\n        taskRepo.resetActiveToInitialState() // set copy of "activeInitialCopy" to active and change it in list\n    ')])],1)},[],!1,null,"4fae4193",null);__webpack_exports__.a=component.exports},156:function(module,__webpack_exports__,__webpack_require__){"use strict";var crud_repo_local_statevue_type_script_lang_ts_=__webpack_require__(0).default.extend({name:"local-state"}),componentNormalizer=__webpack_require__(1),component=Object(componentNormalizer.a)(crud_repo_local_statevue_type_script_lang_ts_,function(){var _vm=this,_h=_vm.$createElement,_c=_vm._self._c||_h;return _c("content-page",{attrs:{title:"CRUD repository"}},[_c("h2",[_vm._v("Local state")]),_vm._v(" "),_c("p",[_vm._v('\n        Sometimes you want to have an oppotunity to reset state of list to last saved state.\n        Meet the "local state". Main idea here is to save changes of the list in separate state and have a getter "localList"\n        which compute an actual local state. Added items will save to "added" state, deleted to "deleted". And localList will\n        return a list without deleted items and with additional added items.\n    ')]),_vm._v(" "),_c("v-code",[_vm._v("\n        // -- Simple example --\n        await taskRepo.updateList()\n        // Now list and localList are the same\n        taskRepo.list // [{id: 1},{id: 2}]\n        taskRepo.localList // [{id: 1},{id: 2}]\n        // Let's add and delete items locally\n        taskRepo\n            .deleteLocal(taskRepo.last)\n            .addLocal({id: null})\n        taskRepo.list // [{id: 1},{id: 2}]\n        taskRepo.localList // [{id: null},{id: 1}]\n        // And send changes to server\n        await taskRepo.flush()\n    ")]),_vm._v(" "),_c("h2",[_vm._v("Local list")]),_vm._v(" "),_c("v-code",[_vm._v("\n        // localList accessor\n        taskRepo.localList\n\n        // Helpful getters\n        taskRepo.isLocalListEmpty // boolean\n        taskRepo.localListItemByIndex(index) // task\n        taskRepo.localListItemById(id) // task\n        taskRepo.localListIndex(task) // number\n        taskRepo.localListIndexById(id) // number\n        taskRepo.localListMap // { [id: string | number]: task }\n        taskRepo.localListIds // string[] | number[]\n        taskRepo.localListLength // number\n        taskRepo.localListLastIndex // number\n        taskRepo.localListLastItem // task\n        taskRepo.localListFirstItem // task\n    ")]),_vm._v(" "),_c("h2",[_vm._v("Local add")]),_vm._v(" "),_c("v-code",[_vm._v("\n\n        // Helpful getters\n        taskRepo.addLocal(task) // add to added\n        taskRepo.deleteAdded(task) // delete from added and deactivate if it was active\n        taskRepo.deleteAllAdded() // delete all from added\n\n        // Helpful getters\n        taskRepo.hasAdded // boolean\n        taskRepo.isAdded // boolean\n        taskRepo.addedById(id) // task\n        taskRepo.isAddedById(id) // boolean\n        taskRepo.addedIndex(task) // number\n        taskRepo.addedMap // { [id: string | number]: task }. Applicable if id generates on client side\n    ")]),_vm._v(" "),_c("h2",[_vm._v("Local delete")]),_vm._v(" "),_c("v-code",[_vm._v("\n\n        // Helpful getters\n        taskRepo.deleteLocal(task) // add to deleted and deactivate if it was active\n        taskRepo.deleteDeleted(task) // delete from deleted\n        taskRepo.deleteAllDeleted() // delete all from deleted\n        taskRepo.deleteActiveLocal() // add active to deleted and deactivate it\n\n        // Helpful getters\n        taskRepo.hasDeleted // boolean\n        taskRepo.isDeleted // boolean\n        taskRepo.deletedById(id) // task\n        taskRepo.isDeletedById(id) // boolean\n        taskRepo.deletedIndex(task) // number\n        taskRepo.deletedMap // { [id: string | number]: task }\n    ")])],1)},[],!1,null,"1aff6a55",null);__webpack_exports__.a=component.exports},157:function(module,__webpack_exports__,__webpack_require__){"use strict";var crud_repo_remote_statevue_type_script_lang_ts_=__webpack_require__(0).default.extend({name:"remote-state"}),componentNormalizer=__webpack_require__(1),component=Object(componentNormalizer.a)(crud_repo_remote_statevue_type_script_lang_ts_,function(){var _h=this.$createElement,_c=this._self._c||_h;return _c("content-page",{attrs:{title:"CRUD repository"}},[_c("h2",[this._v("Remote state")]),this._v(" "),_c("p",[this._v("Easy change remote state and don't worry about local state updating. Clever repo do it for you:")]),this._v(" "),_c("v-code",[this._v("\n        // Send to server add request\n        // Add response to list\n        await taskRepo.add(task)\n\n        // Same as above, but also activate response\n        await taskRepo.addAndActivate(task)\n\n        // Send to server edit request\n        // Replace task by response in list\n        // Replace active by response if it was active\n        await taskRepo.edit(task)\n\n        // Looks for id existence in task and choose add or edit method to call\n        await taskRepo.upsert(task)\n\n        // Same as upsert but also activate response\n        await taskRepo.upsertAndActivate(task)\n\n        // Upsert active task\n        await taskRepo.upsertActive()\n\n        // Send to server delete request\n        // Delete task from list\n        // Deactivate if it was active\n        await taskRepo.delete(task)\n\n        // Delete active\n        await taskRepo.deleteActive()\n\n        // Delete by index in localList\n        await taskRepo.deleteByIndex(index)\n    ")])],1)},[],!1,null,"669dc038",null);__webpack_exports__.a=component.exports},158:function(module,__webpack_exports__,__webpack_require__){"use strict";var crud_repo_synchronizingvue_type_script_lang_ts_=__webpack_require__(0).default.extend({name:"synchronizing"}),componentNormalizer=__webpack_require__(1),component=Object(componentNormalizer.a)(crud_repo_synchronizingvue_type_script_lang_ts_,function(){var _h=this.$createElement,_c=this._self._c||_h;return _c("content-page",{attrs:{title:"CRUD repository"}},[_c("h2",[this._v("Synchronizing of local and remote states")]),this._v(" "),_c("p",[this._v("\n        After you do changes of local state you will need an oppotunity to send this changes to server:\n    ")]),this._v(" "),_c("v-code",[this._v("\n        // If task is not local-added - throw error\n        // Send add request to server\n        // Delete from local-added\n        // Add response to list\n        // Activate response if task was active\n        await taskRepo.flushAdded(task)\n\n        // Same as above but for all local-added tasks\n        await taskRepo.flushAllAdded()\n\n        // If task is not local-deleted - throw error\n        // Send delete request to server\n        // Delete from local-deleted\n        // Delete task from list\n        // Deactivate if task was active\n        await taskRepo.flushDeleted(task)\n\n        // Same as above but for all local-deleted tasks\n        await taskRepo.flushAllDeleted()\n\n        // Call flushAllAdded and flushAllDeleted\n        await taskRepo.flush()\n    ")])],1)},[],!1,null,"78f344d9",null);__webpack_exports__.a=component.exports},159:function(module,__webpack_exports__,__webpack_require__){"use strict";var crud_repo_smart_methodsvue_type_script_lang_ts_=__webpack_require__(0).default.extend({name:"smart-methods"}),componentNormalizer=__webpack_require__(1),component=Object(componentNormalizer.a)(crud_repo_smart_methodsvue_type_script_lang_ts_,function(){var _h=this.$createElement,_c=this._self._c||_h;return _c("content-page",{attrs:{title:"CRUD repository"}},[_c("h2",[this._v("Smart methods")]),this._v(" "),_c("p",[this._v("\n        To reduce the routine a bit more, smart methods have appeared:\n    ")]),this._v(" "),_c("v-code",[this._v("\n        // If task is local-added - call flushAdded\n        // If not - call upsert\n        await taskRepo.smartUpsert(task)\n\n        // Same as above but for active\n        await taskRepo.smartUpsertActive(task)\n\n        // Same as smartUpsert but alse activate\n        await taskRepo.smartUpsertAndActivate(task)\n\n        // If task is local-added - delete from added and deactivate if it was active\n        // If task is local-deleted - call flushDeleted\n        // Else - call delete\n        await taskRepo.smartDelete(task)\n\n        // Same as above but for active\n        await taskRepo.smartDeleteActive(task)\n\n    ")])],1)},[],!1,null,"1315f44c",null);__webpack_exports__.a=component.exports},160:function(module,__webpack_exports__,__webpack_require__){"use strict";var store_module_middlewaresvue_type_script_lang_ts_=__webpack_require__(0).default.extend({name:"what-is-vue-repo"}),componentNormalizer=__webpack_require__(1),component=Object(componentNormalizer.a)(store_module_middlewaresvue_type_script_lang_ts_,function(){var _h=this.$createElement,_c=this._self._c||_h;return _c("content-page",{attrs:{title:"Store module"}},[_c("h2",[this._v("Middlewares")]),this._v(" "),_c("p",[this._v("\n        With middlewares you can add additional functionality to state, mutation, action or getter based on its options or not.\n        It run when annotation is processing.\n    ")])])},[],!1,null,"799f26c0",null);__webpack_exports__.a=component.exports},161:function(module,exports,__webpack_require__){__webpack_require__(162),__webpack_require__(241),module.exports=__webpack_require__(242)},242:function(module,__webpack_exports__,__webpack_require__){"use strict";__webpack_require__.r(__webpack_exports__),function(module){__webpack_require__(16),__webpack_require__(114),__webpack_require__(249);var _storybook_vue__WEBPACK_IMPORTED_MODULE_3__=__webpack_require__(26),vue__WEBPACK_IMPORTED_MODULE_4__=__webpack_require__(0),_components_content_page_vue__WEBPACK_IMPORTED_MODULE_5__=__webpack_require__(146),vue_prism_editor__WEBPACK_IMPORTED_MODULE_8__=(__webpack_require__(345),__webpack_require__(346),__webpack_require__(144)),vue_prism_editor__WEBPACK_IMPORTED_MODULE_8___default=__webpack_require__.n(vue_prism_editor__WEBPACK_IMPORTED_MODULE_8__),_components_v_code__WEBPACK_IMPORTED_MODULE_10__=(__webpack_require__(348),__webpack_require__(153));__webpack_require__(341),vue__WEBPACK_IMPORTED_MODULE_4__.default.component("content-page",_components_content_page_vue__WEBPACK_IMPORTED_MODULE_5__.a),vue__WEBPACK_IMPORTED_MODULE_4__.default.component("prism",vue_prism_editor__WEBPACK_IMPORTED_MODULE_8___default.a),vue__WEBPACK_IMPORTED_MODULE_4__.default.component("v-code",_components_v_code__WEBPACK_IMPORTED_MODULE_10__.a),Object(_storybook_vue__WEBPACK_IMPORTED_MODULE_3__.configure)(function(){__webpack_require__(350),__webpack_require__(351),__webpack_require__(352)},module)}.call(this,__webpack_require__(60)(module))},341:function(module,exports,__webpack_require__){var content=__webpack_require__(342);"string"==typeof content&&(content=[[module.i,content,""]]);var options={hmr:!0,transform:void 0,insertInto:void 0};__webpack_require__(90)(content,options);content.locals&&(module.exports=content.locals)},342:function(module,exports,__webpack_require__){(exports=module.exports=__webpack_require__(343)(!1)).push([module.i,"@import url(https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,600,700);",""]),exports.push([module.i,'section.content {\n  position: relative;\n  padding: 2.2em 0;\n  max-width: 800px;\n  margin: 0 auto; }\n  section.content h1 {\n    margin: 0 0 1em; }\n  section.content h2 {\n    margin: 45px 0 0.8em;\n    padding-bottom: 0.7em;\n    border-bottom: 1px solid #ddd; }\n  section.content p {\n    line-height: 1.6em;\n    margin: 1.2em 0 -1.2em;\n    padding-bottom: 1.2em;\n    position: relative;\n    z-index: 1; }\n\nh1, h2, h3, h4, strong {\n  font-weight: 600;\n  color: #2c3e50; }\n\nh1 {\n  display: block;\n  font-size: 2em;\n  margin-block-start: 0.67em;\n  margin-block-end: 0.67em;\n  margin-inline-start: 0px;\n  margin-inline-end: 0px;\n  font-weight: 600; }\n\nh2 {\n  display: block;\n  font-size: 1.5em;\n  margin-block-start: 0.83em;\n  margin-block-end: 0.83em;\n  margin-inline-start: 0px;\n  margin-inline-end: 0px;\n  font-weight: 600; }\n\nbody {\n  font-family: "Source Sans Pro", "Helvetica Neue", Arial, sans-serif;\n  letter-spacing: 1.1px;\n  color: #34495e; }\n\np {\n  word-spacing: 0.05em; }\n',""])},350:function(module,__webpack_exports__,__webpack_require__){"use strict";__webpack_require__.r(__webpack_exports__),function(module){var _storybook_vue__WEBPACK_IMPORTED_MODULE_0__=__webpack_require__(26),_pages_intro_what_is_vue_repo__WEBPACK_IMPORTED_MODULE_1__=__webpack_require__(148),_pages_intro_quick_start__WEBPACK_IMPORTED_MODULE_2__=__webpack_require__(149);Object(_storybook_vue__WEBPACK_IMPORTED_MODULE_0__.storiesOf)("Introduction",module).add("What is vue-store?",()=>_pages_intro_what_is_vue_repo__WEBPACK_IMPORTED_MODULE_1__.a).add("Quick start",()=>_pages_intro_quick_start__WEBPACK_IMPORTED_MODULE_2__.a)}.call(this,__webpack_require__(60)(module))},351:function(module,__webpack_exports__,__webpack_require__){"use strict";__webpack_require__.r(__webpack_exports__),function(module){var _storybook_vue__WEBPACK_IMPORTED_MODULE_0__=__webpack_require__(26),_pages_store_module_what_is_store_module__WEBPACK_IMPORTED_MODULE_1__=__webpack_require__(150),_pages_store_module_options__WEBPACK_IMPORTED_MODULE_2__=__webpack_require__(151),_pages_store_module_middlewares__WEBPACK_IMPORTED_MODULE_3__=__webpack_require__(160);Object(_storybook_vue__WEBPACK_IMPORTED_MODULE_0__.storiesOf)("Store module",module).add("What is store-module?",()=>_pages_store_module_what_is_store_module__WEBPACK_IMPORTED_MODULE_1__.a).add("Options",()=>_pages_store_module_options__WEBPACK_IMPORTED_MODULE_2__.a).add("Middlewares",()=>_pages_store_module_middlewares__WEBPACK_IMPORTED_MODULE_3__.a)}.call(this,__webpack_require__(60)(module))},352:function(module,__webpack_exports__,__webpack_require__){"use strict";__webpack_require__.r(__webpack_exports__),function(module){var _storybook_vue__WEBPACK_IMPORTED_MODULE_0__=__webpack_require__(26),_pages_crud_repo_what_is_crud_repo__WEBPACK_IMPORTED_MODULE_1__=__webpack_require__(152),_pages_crud_repo_implementing__WEBPACK_IMPORTED_MODULE_2__=__webpack_require__(145),_pages_crud_repo_list_state__WEBPACK_IMPORTED_MODULE_3__=__webpack_require__(154),_pages_crud_repo_active_state__WEBPACK_IMPORTED_MODULE_4__=__webpack_require__(155),_pages_crud_repo_local_state__WEBPACK_IMPORTED_MODULE_5__=__webpack_require__(156),_pages_crud_repo_remote_state__WEBPACK_IMPORTED_MODULE_6__=__webpack_require__(157),_pages_crud_repo_synchronizing__WEBPACK_IMPORTED_MODULE_7__=__webpack_require__(158),_pages_crud_repo_smart_methods__WEBPACK_IMPORTED_MODULE_8__=__webpack_require__(159),_pages_crud_repo_get_methods__WEBPACK_IMPORTED_MODULE_9__=__webpack_require__(147);Object(_storybook_vue__WEBPACK_IMPORTED_MODULE_0__.storiesOf)("CRUD repository",module).add("What is crud repository?",()=>_pages_crud_repo_what_is_crud_repo__WEBPACK_IMPORTED_MODULE_1__.a).add("Implementing",()=>_pages_crud_repo_implementing__WEBPACK_IMPORTED_MODULE_2__.a).add("List state",()=>_pages_crud_repo_list_state__WEBPACK_IMPORTED_MODULE_3__.a).add("Active state",()=>_pages_crud_repo_active_state__WEBPACK_IMPORTED_MODULE_4__.a).add("Local state",()=>_pages_crud_repo_local_state__WEBPACK_IMPORTED_MODULE_5__.a).add("Remote state",()=>_pages_crud_repo_remote_state__WEBPACK_IMPORTED_MODULE_6__.a).add("Synchronizing of local and remote states",()=>_pages_crud_repo_synchronizing__WEBPACK_IMPORTED_MODULE_7__.a).add("Smart methods",()=>_pages_crud_repo_smart_methods__WEBPACK_IMPORTED_MODULE_8__.a).add('"Get" methods',()=>_pages_crud_repo_get_methods__WEBPACK_IMPORTED_MODULE_9__.a)}.call(this,__webpack_require__(60)(module))}},[[161,1,2]]]);
//# sourceMappingURL=main.9106900bb3730c66b67d.bundle.js.map